import {jsx as $4k0tv$jsx} from "preact/jsx-runtime";
import "preact";
import {useRef as $4k0tv$useRef, useEffect as $4k0tv$useEffect, useState as $4k0tv$useState, useCallback as $4k0tv$useCallback} from "preact/hooks";
import {memo as $4k0tv$memo} from "preact/compat";
import {EditorView as $4k0tv$EditorView} from "@codemirror/view";
import {Compartment as $4k0tv$Compartment, EditorState as $4k0tv$EditorState} from "@codemirror/state";
import {setDiagnostics as $4k0tv$setDiagnostics} from "@codemirror/lint";








let $3bb9ddfbd11f7517$var$readOnlyCompartment = new $4k0tv$Compartment();
function $3bb9ddfbd11f7517$export$e6a0daad8304de(value, extensions) {
    return $4k0tv$EditorState.create({
        doc: value,
        extensions: [
            ...extensions,
            $3bb9ddfbd11f7517$var$readOnlyCompartment.of($4k0tv$EditorView.editable.of(false)), 
        ]
    });
}
const $3bb9ddfbd11f7517$var$emittedStates = new WeakSet();
const $3bb9ddfbd11f7517$export$ada5f069beef6fb2 = $4k0tv$memo(function Codemirror({ state: state , onChange: onChange1 = null , readOnly: readOnly = false , diagnostics: diagnostics = null , ...rest }) {
    if (!state) throw new Error("Missing state!");
    const container = $4k0tv$useRef(null);
    const view = $4k0tv$useRef(null);
    const dispatchRefs = $4k0tv$useRef({
    });
    $4k0tv$useEffect(()=>{
        dispatchRefs.current.onChange = onChange1;
    }, [
        onChange1
    ]);
    // --- State ---
    $4k0tv$useEffect(()=>{
        // (subsequent render)
        if (!view.current) return;
        if ($3bb9ddfbd11f7517$var$emittedStates.has(state)) return;
        view.current.setState(state);
    }, [
        state
    ]);
    $4k0tv$useEffect(()=>{
        // (first render)
        let v = view.current = new $4k0tv$EditorView({
            state: state,
            dispatch: (t)=>{
                const { onChange: onChange  } = dispatchRefs.current;
                v.update([
                    t
                ]);
                if (onChange) {
                    $3bb9ddfbd11f7517$var$emittedStates.add(v.state);
                    onChange(v.state, t);
                }
            }
        });
        container.current.appendChild(v.dom);
        return ()=>v.destroy()
        ;
    }, []);
    // --- readOnly ---
    $4k0tv$useEffect(()=>{
        // if readOnly changes (first and subsequent render)
        view.current.dispatch({
            effects: $3bb9ddfbd11f7517$var$readOnlyCompartment.reconfigure($4k0tv$EditorState.readOnly.of(readOnly))
        });
    }, [
        readOnly
    ]);
    $4k0tv$useEffect(()=>{
        // reapply readOnly if the state was changed externally
        if ($3bb9ddfbd11f7517$var$emittedStates.has(state)) return;
        view.current.dispatch({
            effects: $3bb9ddfbd11f7517$var$readOnlyCompartment.reconfigure($4k0tv$EditorState.readOnly.of(readOnly))
        });
    }, [
        readOnly,
        state
    ]);
    // --- Diagnostics ---
    $4k0tv$useEffect(()=>{
        // if diagnostics changes (first and subsequent render)
        view.current.dispatch($4k0tv$setDiagnostics(view.current.state, diagnostics && diagnostics.length > 0 ? diagnostics : []));
    }, [
        diagnostics
    ]);
    $4k0tv$useEffect(()=>{
        // reapply diagnostics if the state was changed externally
        if ($3bb9ddfbd11f7517$var$emittedStates.has(state)) return;
        view.current.dispatch($4k0tv$setDiagnostics(view.current.state, diagnostics && diagnostics.length > 0 ? diagnostics : []));
    }, [
        diagnostics,
        state
    ]);
    return(/*#__PURE__*/ $4k0tv$jsx("div", {
        ref: container,
        ...rest
    }));
});
function $3bb9ddfbd11f7517$export$a70089b54cfe6d6a({ value: value , onChange: _onChange , readOnly: readOnly , diagnostics: diagnostics , extensions: extensions ,  }) {
    const [state, setState] = $4k0tv$useState($3bb9ddfbd11f7517$export$e6a0daad8304de(value, extensions));
    $4k0tv$useEffect(()=>{
        if (value !== state.doc.toString()) setState($3bb9ddfbd11f7517$export$e6a0daad8304de(value, extensions));
    }, [
        value
    ]);
    $4k0tv$useEffect(()=>{
        setState($3bb9ddfbd11f7517$export$e6a0daad8304de(value, extensions));
    }, [
        extensions
    ]);
    const onChange = $4k0tv$useCallback((newState, transaction)=>{
        setState(newState);
        if (!transaction.changes.empty) _onChange(newState.doc.toString());
    }, []);
    return(/*#__PURE__*/ $4k0tv$jsx($3bb9ddfbd11f7517$export$ada5f069beef6fb2, {
        state: state,
        onChange: onChange,
        readOnly: readOnly,
        diagnostics: diagnostics,
        class: "editor"
    }));
}


export {$3bb9ddfbd11f7517$export$e6a0daad8304de as createState, $3bb9ddfbd11f7517$export$ada5f069beef6fb2 as Codemirror, $3bb9ddfbd11f7517$export$a70089b54cfe6d6a as CodemirrorEditor};
//# sourceMappingURL=index.es.js.map
